'This demo tests C3088 interface board
'
'This uses 1 COG for all the serial ports
'
con
  _clkmode = xtal1 + pll16x                '
  _xinfreq = 5_000_000                     '

obj
  uarts         : "pcFullDuplexSerial4FC"               '1 COG for 4 serial ports
  cams          : "camov6620"                           '1 or 2 COGs required
  config        : "config"                              'no COG required
  timconfig     : "timconfig"                           'no COG required
  ipr           : "ipr"                                 '1 COG required
      
var
  long  stack[50]                                       'requires stack of at least 32
  long  cog
  long  Ptr[2]
  long  SizeX[2]
  long  SizeY[2]
    
pub main | time
  config.Init(@configinfo)
  waitcnt(clkfreq*3 + cnt)

  uarts.Init(config.GetPin(CONFIG#I2C_SCL1))
  're-use IPR pins for debugging
  uarts.AddPort(0,config.GetPin(TIMCONFIG#IPR_RX),config.GetPin(TIMCONFIG#IPR_TX), {
}   UARTS#PINNOTUSED,UARTS#PINNOTUSED,UARTS#DEFAULTTHRESHOLD, {
}   UARTS#NOMODE,UARTS#BAUD115200)                      'Add debug port
  uarts.Start                                           'Start the ports
  
  uarts.str(0,string("Starting",13))

  cams.Init
  cams.SetPin(0,CAMS#DATAPIN,config.GetPin(TIMCONFIG#TOV6620_DATA))
  cams.SetPin(0,CAMS#PWDNPIN,config.GetPin(TIMCONFIG#TOV6620_PWDN))
  cams.SetPin(0,CAMS#CAMRSTPIN,config.GetPin(TIMCONFIG#TOV6620_RST))
  cams.SetPin(0,CAMS#FIFORSTPIN,config.GetPin(TIMCONFIG#TFIFO_RST))
  cams.SetPin(0,CAMS#WRSTPIN,config.GetPin(TIMCONFIG#TFIFO_WRST1))
  cams.SetPin(0,CAMS#RRSTPIN,config.GetPin(TIMCONFIG#TFIFO_RRST1))
  cams.SetPin(0,CAMS#RCKPIN,config.GetPin(TIMCONFIG#TFIFO_RCK1))
  cams.SetPin(0,CAMS#OEPIN,config.GetPin(TIMCONFIG#TFIFO_OE1))
  cams.SetPin(0,CAMS#WEEPIN,config.GetPin(TIMCONFIG#TFIFO_WEE1))
  cams.SetPin(0,CAMS#SCLPIN,config.GetPin(CONFIG#I2C_SCL2))
  cams.SetPin(0,CAMS#SDAPIN,config.GetPin(CONFIG#I2C_SDA2))
  cams.SetPin(0,CAMS#HREFPIN,config.GetPin(TIMCONFIG#TFIFO_HREF1))
  cams.SetPin(0,CAMS#VSYNPIN,config.GetPin(TIMCONFIG#TFIFO_VSYN1))
  cams.SetPin(1,CAMS#WRSTPIN,config.GetPin(TIMCONFIG#TFIFO_WRST2))
  cams.SetPin(1,CAMS#RRSTPIN,config.GetPin(TIMCONFIG#TFIFO_RRST2))
  cams.SetPin(1,CAMS#RCKPIN,config.GetPin(TIMCONFIG#TFIFO_RCK2))
  cams.SetPin(1,CAMS#OEPIN,config.GetPin(TIMCONFIG#TFIFO_OE2))
  cams.SetPin(1,CAMS#WEEPIN,config.GetPin(TIMCONFIG#TFIFO_WEE2))
  cams.SetPin(1,CAMS#SCLPIN,config.GetPin(CONFIG#I2C_SCL1))
  cams.SetPin(1,CAMS#SDAPIN,config.GetPin(CONFIG#I2C_SDA1))
  cams.SetPin(1,CAMS#HREFPIN,config.GetPin(TIMCONFIG#TFIFO_HREF2))
  cams.SetPin(1,CAMS#VSYNPIN,config.GetPin(TIMCONFIG#TFIFO_VSYN2))
  cams.Start
  Ptr[0] := cams.GetFramePtr(0)
  SizeX[0] := cams.GetFrameSizeX(0)
  SizeY[0] := cams.GetFrameSizeY(0)
  Ptr[1] := cams.GetFramePtr(1)
  SizeX[1] := cams.GetFrameSizeX(1)
  SizeY[1] := cams.GetFrameSizeY(1)

  cog := cognew(BackGround,@stack) + 1                  'Start the background Cog

  repeat
  
pub BackGround | C,X,Y
'minimize processing in this cog, i.e. dont send to serial ports e.g. debug
'dont call waitcnt, etc. Dont call blocking receives from serial ports - use rxcheck
  repeat
    repeat C from 0 to 1
      repeat X from 0 to SizeX[C]
        repeat Y from 0 to SizeY[C]
          uarts.hex(0,BYTE[Ptr[C]][Y*SizeY[C]+X],2)
        uarts.tx(0,13)
      uarts.tx(0,13)

DAT
configinfo    word TIMCONFIG#TOV6620_DATA       'pin 0
              word TIMCONFIG#TOV6620_DATA       'pin 1
              word TIMCONFIG#TOV6620_DATA       'pin 2
              word TIMCONFIG#TOV6620_DATA       'pin 3
              word TIMCONFIG#TOV6620_DATA       'pin 4
              word TIMCONFIG#TOV6620_DATA       'pin 5
              word TIMCONFIG#TOV6620_DATA       'pin 6
              word TIMCONFIG#TOV6620_DATA       'pin 7
              word TIMCONFIG#TOV6620_PWDN       'pin 8
              word TIMCONFIG#TOV6620_RST        'pin 9
              word TIMCONFIG#TFIFO_RST          'pin 10
              word TIMCONFIG#TFIFO_WRST1        'pin 11
              word TIMCONFIG#TFIFO_WRST2        'pin 12
              word CONFIG#NOT_USED              'pin 13
              word TIMCONFIG#IPR_TX             'pin 14
              word TIMCONFIG#IPR_RX             'pin 15
              word TIMCONFIG#TFIFO_RRST1        'pin 16
              word TIMCONFIG#TFIFO_RCK1         'pin 17
              word TIMCONFIG#TFIFO_OE1          'pin 18
              word TIMCONFIG#TFIFO_WEE1         'pin 19
              word CONFIG#I2C_SCL2              'pin 20
              word CONFIG#I2C_SDA2              'pin 21
              word TIMCONFIG#TFIFO_HREF1        'pin 22
              word TIMCONFIG#TFIFO_VSYN1        'pin 23
              word TIMCONFIG#TFIFO_RRST2        'pin 24
              word TIMCONFIG#TFIFO_RCK2         'pin 25
              word TIMCONFIG#TFIFO_OE2          'pin 26
              word TIMCONFIG#TFIFO_WEE2         'pin 27
              word CONFIG#I2C_SCL1              'pin 28
              word CONFIG#I2C_SDA1              'pin 29
              word TIMCONFIG#TFIFO_HREF2        'pin 30
              word TIMCONFIG#TFIFO_VSYN2        'pin 31
              byte CONFIG#NTSC           